%bcond_with     debug
%bcond_with     debuginfo

# Define the kmod package name here.
%define kmod_name pexml

%{!?RPM_GIT_VERSION:%define RPM_GIT_VERSION unknown}

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion %(rpm -q kernel-devel|sed -e 's/^[a-z-]*//'|sort -n|tail -n 1|sed -e 's/\(PAE\|xenU\|xen\|smp\|hugemem\)//g')}

Name:    %{kmod_name}-kmod
Version: 1.37.6
Release: %{RPM_GIT_VERSION}%{?dist}
Group:   System Environment/Kernel
License: GPL
Summary: M-Link kernel modules
URL:     http://afi.jinr.ru/mlink

BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%if %{undefined kernel_module_package_buildreqs}
BuildRequires: redhat-rpm-config kernel-rpm-macros elfutils-libelf-devel kmod
%else
BuildRequires: %kernel_module_package_buildreqs
%endif
ExclusiveArch: i686 x86_64

# Sources
Source0:  mlink-%{version}.tar.gz

# userspace package with udev rules
Requires: pexml-kmod-common

%description
M-Link is a custom communication interface based on packet structure like
Ethernet. It is used with ADCM, VMEDAQ projects.

%kernel_module_package -n %{kmod_name} -p %{_sourcedir}/kmod-preamble

%define ksrc %{_usrsrc}/kernels/%{kverrel}
%define kobj %{ksrc}


%prep
if ! [ -d "%{ksrc}"  ]; then
        echo "Kernel build directory isn't set properly, cannot continue"
        exit 1
fi

%if %{with debug}
%define debug --enable-debug
%else
%define debug --disable-debug
%endif

%if %{with debuginfo}
%define debuginfo --enable-debuginfo
%else
%define debuginfo --disable-debuginfo
%endif

#setup -n %{kmod_name}-%{version}
%setup -q -n mlink-%{version}

%build

%if %{with debug}
%define debug_options DEBUG=yes
%endif

%{__make} -C %{ksrc} %{?_smp_mflags} %{?debug_options} modules M=$PWD/driver

%install
%{__make} -C %{ksrc} modules_install M=$PWD/driver \
        INSTALL_MOD_PATH=%{buildroot} \
        DESTDIR=${RPM_BUILD_ROOT} \
        INSTALL_MOD_DIR=extra/%{kmod_name}
%{__rm} -f %{buildroot}/lib/modules/%{kverrel}/modules.*

# find-debuginfo.sh only considers executables
%{__chmod} u+x  %{buildroot}/lib/modules/%{kverrel}/extra/*/*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Wed Oct 16 2019  <Ilja.Slepnev@jinr.ru> - 1.37.2
- include git hash in rpm release string

* Thu Oct  3 2019  <Ilja.Slepnev@jinr.ru> - 1.37
- RHEL8, Linux 5.x compatibility
- added ioctls ML_IOC_READ_BOARD_INFO, ML_IOC_GET_SERIAL_ID

* Thu Apr 19 2018  <Ilja.Slepnev@jinr.ru> - 1.35
- Flash programmer interface

* Wed Feb  7 2018  <Ilja.Slepnev@jinr.ru> - 1.34
- GTX, SFP control/status

* Tue Jul 28 2015  <Ilja.Slepnev@jinr.ru> - 1.33.3
- rpm provides mlink-kmod-common, pexml-kmod-common

* Fri Sep 27 2013  <Ilja.Slepnev@jinr.ru> - 1.33
- correct status report with firmware r.15176

* Thu Nov 29 2012  <Ilja.Slepnev@jinr.ru> - 
- EL6 compatible spec file

* Wed May 13 2009  <Ilja.Slepnev@jinr.ru> - 
- Fixed package name

* Tue May 12 2009  <Ilja.Slepnev@jinr.ru> - 
- Split in two packages: mlink and mlink-kmod

* Wed Apr 22 2009  <Ilja.Slepnev@jinr.ru> - 
- 1.30: build with kmodtool2. Package name changed: mlink-utils, mlink-kmod

* Mon Apr 20 2009  <Ilja.Slepnev@jinr.ru> - 
- removed mlink.ko file. use melink.ko

* Wed Apr 08 2009  <Ilja.Slepnev@jinr.ru> - 
- 1.29: Removed special run-mode. Packet mode only.

* Wed Mar 25 2009  <Ilja.Slepnev@jinr.ru> - 
- Fixed communication problem caused by receiver_reset() in RXC handler
- testlink: Fixed clock locking problem when changing loopback mode

* Tue Mar  3 2009  <Ilja.Slepnev@jinr.ru> - 
- Changed version to 1.28
- Added MlinkDevice interface class

* Thu Feb 12 2009  <Ilja.Slepnev@jinr.ru> - 
- Added control frame loopback bit

* Thu Dec 11 2008  <Ilja.Slepnev@jinr.ru> - 
- Handle link up/down status on reset, use OSD bit

* Fri Nov 28 2008  <Ilja.Slepnev@jinr.ru> - 
- defined 'kdir' macro
- fixed x86_64 warnings

* Thu Nov 27 2008  <Ilja.Slepnev@jinr.ru> - 
- spec file corrected to build on Fedora 10.

* Tue Nov 18 2008  <Ilja.Slepnev@jinr.ru> - 
- Initial build.

